; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "IP45"
!define PRODUCT_VERSION "1.0"
!define PRODUCT_PUBLISHER "IP45"
;!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\ip45.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI2.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
;!define MUI_LICENSEPAGE_RADIOBUTTONS
;!insertmacro MUI_PAGE_LICENSE "c:\path\to\licence\YourSoftwareLicence.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_NOAUTOCLOSE
;!define MUI_FINISHPAGE_RUN "$INSTDIR\ip45d.exe"
!insertmacro MUI_PAGE_FINISH
; Uninstaller pages
!insertmacro MUI_UNPAGE_WELCOME
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
!define MUI_UNFINISHPAGE_NOAUTOCLOSE
!insertmacro MUI_UNPAGE_FINISH

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

;--------------------------------
;Macros

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "ip45setup.exe"
InstallDir "$PROGRAMFILES64\IP45"
;InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show
RequestExecutionLevel admin

;--------------------
;Pre-install section

Section -pre

  DetailPrint "Stopping service"
  nsExec::ExecToLog '"$INSTDIR\ip45serv.exe" stop'
  Pop $R0 # return value/error/timeout
  Sleep 2000

  DetailPrint "Removing service"
  nsExec::ExecToLog '"$INSTDIR\ip45serv.exe" uninstall'
  Pop $R0 # return value/error/timeout
  Sleep 1000

SectionEnd

Section "MainSection" SEC01
  SetOverwrite on
  SetOutPath "$INSTDIR"
  SetOverwrite try
  CreateDirectory "$SMPROGRAMS\IP45"
  CreateShortCut "$SMPROGRAMS\IP45\Ip45.lnk" "$INSTDIR\ip45d.exe"

  SetOutPath "$INSTDIR"

  File "ip45d.exe"
  File "ip45serv.exe"

  ;install as a service (to be started manually from service control manager)
  DetailPrint "Service INSTALL"
  nsExec::ExecToLog '"$INSTDIR\ip45serv.exe" install'
  Pop $R0 # return value/error/timeout
SectionEnd

Section -AdditionalIcons
  CreateShortCut "$SMPROGRAMS\IP45\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  ; Store install folder in registry
  SetRegView   64
  WriteUninstaller "$INSTDIR\uninst.exe"
    
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
;  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
 #Determine the bitness of the OS and enable the correct section
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
        ClearErrors
        SetShellVarContext all
        ${If} "${ARCH}" == "x86_64"
                SetRegView 64
        ${EndIf}

FunctionEnd

Section Uninstall

  ; Stop ip45srv if currently running
  DetailPrint "Stopping service"
  nsExec::ExecToLog '"$INSTDIR\ip45serv.exe" stop'
  Pop $R0 # return value/error/timeout
  Sleep 2000

  DetailPrint "Removing service"
  nsExec::ExecToLog '"$INSTDIR\ip45serv.exe" uninstall'
  Pop $R0 # return value/error/timeout
  Sleep 1000
  
;  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\ip45d.exe"
  Delete "$INSTDIR\ip45serv.exe"
  Delete "$INSTDIR\uninst.exe"

  Delete "$SMPROGRAMS\IP45\Uninstall.lnk"
  Delete "$SMPROGRAMS\IP45\Ip45.lnk"
  Delete "$DESKTOP\Ip45.lnk"

  RMDir /r $SMPROGRAMS\Ip45
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
;  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  DeleteRegKey HKLM SOFTWARE\IP45
;  DeleteRegKey HKLM "Software\${PRODUCT_NAME}"
  SetAutoClose true
SectionEnd
